package edu.harvard.mgh.purcell.gplink.data;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.Vector;

import org.apache.log4j.Logger;

import com.sshtools.j2ssh.SshClient;
import com.sshtools.j2ssh.session.SessionChannelClient;

import edu.harvard.mgh.purcell.gplink.mainGUI.ErrorDialog;

public class SendCommand {

//	 Define a static logger variable so that it references the
	   // Logger instance named "MyApp".
	static Logger logger = Logger.getLogger(SendCommand.class);
	
	Project data;
	SshClient conn;
	String command;
	public Vector <String> outputLines;
	public Vector <String> errorLines;
	
	public SendCommand(String cmd, Project d){
		data = d;
		command = cmd;
		conn = data.getConn();
		outputLines = new Vector<String>();
		errorLines = new Vector<String>();
	}
	
	public void execute(){
		
			logger.info("Executing command ["+command+"].");
			
			SessionChannelClient sess = null;
			try {
				sess = conn.openSessionChannel();
			} catch (IOException e) {
				//new ErrorDialog(data, "Error! Can not open session channel. \n " +
				//		"execute():SendCommand.java");
				logger.error("Can not open session channel.");
				data.connectionLost();
				return;
			}
			
			try {
				sess.executeCommand(command);
			} catch (IOException e) {
				new ErrorDialog(data, "Error executing ["+ command +"]. \n " +
				"execute():SendCommand.java");
				logger.error("Cannot execute ["+ command +"].");
				return;
			}
			
			try{
			/**
			  * Reading from the session InputStream
			  */
			  InputStream in = sess.getInputStream();
			  InputStreamReader isr = new InputStreamReader(in);
			  BufferedReader br = new BufferedReader(isr);
			  
			  String line = br.readLine();
			  
			  while(line != null) {
				  outputLines.add(line);
				  line = br.readLine();
			  }
			  
			  /**
			  * Reading from the session ErrStream
			  */
			  InputStream err = sess.getStderrInputStream();
			  isr = new InputStreamReader(err);
			  br = new BufferedReader(isr);

			  line = br.readLine();
			  
			  while(line != null) {
				  errorLines.add(line);
				  line = br.readLine();
			  }
		
			//close up the session
			sess.close();
			} catch(IOException e){
				new ErrorDialog(data, "Error reading the command results " +
						"["+command+"].\n execute():SendCommand.java");
				logger.error("Error reading the command results " +
						"["+command+"].");
			}
	}
	
}
