package edu.harvard.mgh.purcell.gplink.forms;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.ButtonGroup;

import edu.harvard.mgh.purcell.gplink.base_form.Forms;
import edu.harvard.mgh.purcell.gplink.mainGUI.*;

@SuppressWarnings("serial")
public class MissingnessForm extends Forms {

	Forms.myRadioButton rates, testByPheno, testByGeno;
	Forms.myJTextField mishapNum;

	public MissingnessForm(MainFrame mf) {
		super(mf, "Missingness");
	}
	
	@Override
	protected void createBody() {
		
		ButtonGroup pickOne = new ButtonGroup();
		pickOne.add(rates);
		rates.setSelected(true);
		pickOne.add(testByPheno);
		pickOne.add(testByGeno);
		
		body.setLayout(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.HORIZONTAL;	
		c.gridwidth = 2;
		body.add(rates, c);
		c.gridy = 1;
		body.add(testByPheno, c);
		c.gridy = 2;
		c.gridwidth = 1;
		body.add(testByGeno, c);
		c.gridx = 1;
		body.add(mishapNum, c);
				
	}

	@Override
	protected String processBody() {
		String ans = "";
		
		if(rates.isSelected())
			ans = "--missing";
		if(testByPheno.isSelected())
			ans = "--test-missing";
		if(testByGeno.isSelected()){
			ans = "--test-mishap";
			if(mishapNum.getText().matches("\\d+"))
				ans +=" --mishap-window " + mishapNum.getText();
		}
		
		return ans;
	}

	@Override
	protected boolean isBodyValid() {
		if(!(rates.isSelected() 
				|| testByPheno.isSelected() 
				|| testByGeno.isSelected())){
//			information.setText("Must selected a test.");
			return false;
		}
		
		return true;
	}

	@Override
	protected void initalize() {
		rates = new myRadioButton("Rates Summary (--missing)");
		testByPheno = new myRadioButton("Test by Phenotype (--test-missing)");
		mishapNum = new myJTextField("1", 3);
		testByGeno = new myRadioButton("Test by Geonotype (--test-mishap) Optional window (--mishap-window)", mishapNum);
		
	}

}
