package edu.harvard.mgh.purcell.gplink.mainGUI;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JTextArea;

import org.apache.log4j.Logger;

import edu.harvard.mgh.purcell.gplink.data.AutoUpdater;
import edu.harvard.mgh.purcell.gplink.data.Project;

/**
 * A wrapper class for JOptionPane that displays our gPLINK
 * errors.
 * @author Kathe
 *
 */
@SuppressWarnings("serial")
public class ErrorDialog extends JFrame{
	
	Logger logger = Logger.getLogger(ErrorDialog.class);
	//private MainFrame parent;
	private Project data;
	private String errorMessage;
	private int max_line_length = 30;

	private void niceClose(){
		logger.info("Closing error message nicely.");
		if(data.getBrowse() == false)
			ErrorDialog.this.data.gplinkLog 
				= new AutoUpdater(ErrorDialog.this.data);
		ErrorDialog.this.dispose();
	}
	ActionListener close = new ActionListener(){
		public void actionPerformed(ActionEvent e) {
			niceClose();
		}		
	};
	
	WindowListener properClosing = new WindowListener(){

		public void windowActivated(WindowEvent e) {}
		public void windowClosed(WindowEvent e) {}
		public void windowClosing(WindowEvent e) {
			niceClose();
		}
		public void windowDeactivated(WindowEvent e) {}
		public void windowDeiconified(WindowEvent e) {}
		public void windowIconified(WindowEvent e) {}
		public void windowOpened(WindowEvent e) {}		
	};
	private String wrap(String text){
//		split the message at the white spaces and
		//...put the message back together such that
		//...there is a \n atleast every 20 charactures
		
		if(text.length() > max_line_length){
			
			int index = max_line_length - 1;
			while(index < text.length()){
				if(text.charAt(index) == (' ')){
					text = text.substring(0, index) + " \n"
						+ text.substring(index, text.length());
					index = index + max_line_length;
				}
				else{
					index ++;
					
				}
			}
		}
		return text;
	}
	
	private void createLayout(){
		this.getContentPane().setLayout(
				new BoxLayout(this.getContentPane(), 
						BoxLayout.PAGE_AXIS));
		JTextArea message = new JTextArea(5, max_line_length);
		message.setText(errorMessage);
		getContentPane().add(message);
		
		JButton ok = new JButton("OK");
		ok.addActionListener(close);
		getContentPane().add(ok);
	}
	
	public ErrorDialog(MainFrame frame, String message){
		super("gPLINK Error");
		data = frame.data;
		errorMessage = wrap(message);
		createLayout();
		
		if(frame.data.gplinkLog != null)
			frame.data.gplinkLog.cancel();
		
		pack();
		setVisible(true);
		this.toFront();
		//Take this out to avoid deadlocks
		/*JOptionPane.showMessageDialog(frame,
			    errorMessage,
			    "GPLINK error",
			    JOptionPane.ERROR_MESSAGE);
		*/	   
	}
	
	public ErrorDialog(Project d, String message){
		super("gPLINK Error");
		data = d;
		errorMessage = wrap(message);
		createLayout();
		
		if(data.gplinkLog != null)
			data.gplinkLog.cancel();
		
		pack();
		setVisible(true);
		//Take this out to avoid deadlocks
		/*JOptionPane.showMessageDialog(frame,
			    errorMessage,
			    "GPLINK error",
			    JOptionPane.ERROR_MESSAGE);
		*/	   
	}
}
