package edu.harvard.mgh.purcell.gplink.mainGUI;

import java.awt.BorderLayout;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.Vector;

import javax.swing.DefaultListModel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.border.TitledBorder;

import edu.harvard.mgh.purcell.gplink.base_form.GeneralUtil;

@SuppressWarnings("serial")
public class FolderView extends JPanel {

	MainFrame parent;
	
	DefaultListModel listmodel;
	
	Vector <String> fileInfo;
	
	JList files;
	
	public void updateView(){
		createList();
	}
	
	private MouseListener launchPopUp = new MouseListener(){
		public void mouseClicked(MouseEvent arg0) {
			checkEvent(arg0);
		}
		public void mouseEntered(MouseEvent arg0) {}
		public void mouseExited(MouseEvent arg0) {}
		public void mousePressed(MouseEvent arg0) {
			checkEvent(arg0);
		}
		public void mouseReleased(MouseEvent arg0) {
			checkEvent(arg0);			
		}
		
		/**
		 * If this is a popup event then create a popup menu.
		 * @param e the mouse event that triggered the tree selection
		 */
		private void checkEvent(MouseEvent e) {
			//check for popup trigger
			if (e.isPopupTrigger()) {
				Object[] selectedFiles = FolderView.this.files.getSelectedValues();
				String [] selectedFilenames = new String [selectedFiles.length];
				
				for(int i =0; i < selectedFiles.length; i ++){
					selectedFilenames[i] = selectedFiles[i].toString().split(":")[0];
				}
				//check validity of the selection
				if (selectedFiles != null) {
					//create a new popup from this path
					FolderListPopUp p = new FolderListPopUp(parent, selectedFilenames);
					//show the popup
					p.show(e.getComponent(), e.getX(), e.getY());
				}
			}
		}
		
	};
	
	public void clearViewer(){
		listmodel.clear();
		setBorder(new TitledBorder("Folder viewer"));
	}
	
	private void createList(){
		fileInfo = parent.data.getFileList();
		
		if(parent.data.getRoot() != null){
			if(parent.data.isRemote()){
				setBorder(new TitledBorder("Folder Viewer: "+ GeneralUtil.fileName(parent.data.getRemoteFile())));
			}else{
				setBorder(new TitledBorder("Folder Viewer: "+ parent.data.getRoot().getName()));
			}
		}else {
			setBorder(new TitledBorder("Folder viewer"));
		}
		
		//make sure that we've actually pulled a folder
		//...list
		if(fileInfo.isEmpty())
			return;
		else
			listmodel.clear();
		
		for(String file: fileInfo){
			file = GeneralUtil.fileName(file);
			if(!file.startsWith("."))
				listmodel.addElement(file + ": "+ parent.data.getFolderFileNode(file));
		}
		
		
		
	}
	
	FolderView(MainFrame mf){
		super();
		setLayout(new BorderLayout());
		parent = mf;
		listmodel = new DefaultListModel();
		createList();
		files = new JList(listmodel);
		files.setSelectedIndex(JList.VERTICAL);
		files.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		files.addMouseListener(launchPopUp);
		setBorder(new TitledBorder("Folder viewer"));
		add(new JScrollPane(files));
	}
	
}
